// -*- Funnel -*-

/**
 * $Author: ysaidji $
 * $Id: AssocDefault.m4,v 1.1.1.1 2001/06/26 13:20:20 ysaidji Exp $
 */

def removeMe = include[__AssocDefaultType__]

// __begin_AssocX__
def AssocXDefault[k] (map:__AssocXModule__[k]) : AssocXDefaultModule[k] = {

  def fromSeqUsingInsertSeq[a] (kvs) = (map.empty[a]).insertSeq (kvs) 
  def insertSeqUsingFoldr[a] (kvs) (m) = kvs.foldr ((key,x) | m:__AssocX__[k,a] | m.insert (key) (x)) (m)
  def unionSeqUsingReduce[a] (ms) = ms.reducel (m1 | m2 | m2.union (m1)) (map.empty[a])
  def deleteSeqUsingFoldr[a] (ks) (m) = ks.foldr (key | m:__AssocX__[k,a] | m.delete(key)) m
  def countUsingMember[a] (m) (k) = if (m.member (k)) 1 else 0
  def lookupAllUsingLookupM[a] (m) (k) = {
    val (b,x) = m.lookupM (k);
    if (b) List.single[a] x else List.empty[a]
  }
  def lookupWithDefaultUsingLookupM[a] (d) (m) (k) = {
    val (b,x) = m.lookupM (k);
    if (b) x else d
  }
  def partitionUsingFilter[a] (f) (m) = (m.filter (f), m.filter (x | !(f (x))))
  def elementsUsingFold[a] (m) = m.fold (List.cons[a]) (List.empty[a])

}

// __begin_FiniteMapX__
def FiniteMapXDefault[k] (map:__FiniteMapXModule__[k]) : FiniteMapXDefaultModule[k] = {

  def insertWithUsingLookupM[a] (f) (k) (x) (m) = {
    val (b,y) = m.lookupM (k);
    if (b)
      m.insert (k) (f (x) (y))
    else
      m.insert (k) (x)
  }
  def fromSeqWithUsingInsertSeqWith[a] (f) (kvs) = (map.empty[a]).insertSeqWith (f) (kvs)
  def fromSeqWithKeyUsingInsertSeqWithKey[a] (f) (kvs) = (map.empty[a]).insertSeqWithKey (f) (kvs)
  def insertWithKeyUsingInsertWith[a] (f) (k) (x) (m) = m.insertWith (f (k)) (k) (x)
  def insertSeqWithUsingInsertWith[a] (f) (kvs) (m) = kvs.foldr ((k,x)|m:__FiniteMapX__[k,a]|m.insertWith (f) (k) (x)) (m)
  def insertSeqWithKeyUsingInsertWithKey[a] (f) (kvs) (m) = kvs.foldr ((k,x)|m:__FiniteMapX__[k,a]|m.insertWithKey (f) (k) (x)) (m)
  def unionSeqWithUsingReduce[a] (f) (ms) = ms.reducel (m1 | m2 | m2.unionWith (f) (m1)) (map.empty[a])
  def unionSeqWithUsingFoldr[a] (f) (ms) = ms.foldr (m1 | m2:__FiniteMapX__[k,a] | m2.unionWith (f) (m1)) (map.empty[a])
  def subsetUsingSubsetEq[a,b] (m1) (m2) = (m1.subsetEq (m2)) && (m1.size < m2.size)

}

// __begin_Assoc__
def AssocDefault[k] (map:__AssocModule__[k]) : AssocDefaultModule[k] = {

  def toSeqUsingFoldWithKey[a] (m) = m.foldWithKey (k | v | kvs:List[(k,a)] | List.cons[(k,a)] (k,v) (kvs)) (List.empty[(k,a)])
  def keysUsingFoldWithKey[a] (m) = m.foldWithKey (k | v | ks:List[k] | List.cons[k] (k) (ks)) (List.empty[k])

}

// __begin_FiniteMap__
def FiniteMapDefault[k] (map:__FiniteMapModule__[k]) : FiniteMapDefaultModule[k] = {

  def unionWithUsingInsertWith[a] (f) (m1) (m2) = m1.foldWithKey (k|x|m:__FiniteMap__[k,a]|m.insertWith (f) (k) (x)) (m2)
  def unionWithKeyUsingInsertWithKey[a] (f) (m1) (m2) = m1.foldWithKey (k|x|m:__FiniteMap__[k,a]|m.insertWithKey (f) (k) (x)) (m2)
  def unionSeqWithKeyUsingReduce[a] (f) (ms) = ms.reducel (m1 | m2 | m2.unionWithKey (f) (m1)) (map.empty[a])
  def unionSeqWithKeyUsingFoldr[a] (f) (ms) = ms.foldr (m1 | m2:__FiniteMap__[k,a] | m2.unionWithKey (f) (m1)) (map.empty[a])
  def intersectWithUsingLookupM[a,b,c] (f) (m1) (m2) = {
    def ins (k:k) (x:a) (m:__FiniteMap__[k,c]) = {
      val (b:boolean,y:b) = m2.lookupM (k);
      if (b) m.insert (k) (f (x) (y))
      else m
    }
    m1.foldWithKey (ins) (map.empty[c])
  }
  def intersectWithKeyUsingLookupM[a,b,c] (f) (m1) (m2) = {
    def ins (k:k) (x:a) (m:__FiniteMap__[k,c]) = {
      val (b:boolean,y:b) = m2.lookupM (k);
      if (b) m.insert (k) (f (k) (x) (y))
      else m
    }
    m1.foldWithKey (ins) (map.empty[c])
  }
  def differenceUsingDelete[a,b] (m1) (m2) = {
    def del (k:k) (x:b) (m:__FiniteMap__[k,a]) = m.delete (k)
    m2.foldWithKey (del) (m1)
  }
  def subsetEqUsingMember[a,b] (m1) (m2) = {
    def mem (k:k) (x:a) (b) = (m2.member (k)) && b
    m1.foldWithKey (mem) (true)
  }

}

// divert(0)
newtype __AssocDefault__ = {
  def empty:any
}
