// -*- Funnel -*-

/**
 * $Author: ysaidji $
 * $Id: AssocDefaultType.m4,v 1.1.1.1 2001/06/26 13:20:20 ysaidji Exp $
 */

def removeMe = include[__AssocType__]

// __begin_AssocX__
newtype AssocXDefaultModule[k] = {

  def fromSeqUsingInsertSeq[a] (kvs:__Seq__[(k,a)]) : __AssocX__[k,a]
  def insertSeqUsingFoldr[a] (kvs:__Seq__[(k,a)]) (m:__AssocX__[k,a]) : __AssocX__[k,a]
  def unionSeqUsingReduce[a] (ms:__Seq__[__AssocX__[k,a]]) : __AssocX__[k,a]
  def deleteSeqUsingFoldr[a] (ks:__Seq__[k]) (m:__AssocX__[k,a]) : __AssocX__[k,a]
  def countUsingMember[a] (m:__AssocX__[k,a]) (k:k) : int
  def lookupAllUsingLookupM[a] (m:__AssocX__[k,a]) (k:k) : __Seq__[a]
  def lookupWithDefaultUsingLookupM[a] (d:a) (m:__AssocX__[k,a]) (k:k) : a
  def partitionUsingFilter[a] (f: a -> boolean) (m:__AssocX__[k,a]) : (__AssocX__[k,a],__AssocX__[k,a])
  def elementsUsingFold[a] (m:__AssocX__[k,a]) : __Seq__[a]
 
}

// __begin_FiniteMapX__
newtype FiniteMapXDefaultModule[k] = {

  def insertWithUsingLookupM[a] (f: a -> a -> a) (k:k) (x:a) (m:__FiniteMapX__[k,a]) : __FiniteMapX__[k,a]
  def fromSeqWithUsingInsertSeqWith[a] (f: a -> a -> a) (kvs:__Seq__[(k,a)]) : __FiniteMapX__[k,a]
  def fromSeqWithKeyUsingInsertSeqWithKey[a] (f: k -> a -> a -> a) (kvs:__Seq__[(k,a)]) : __FiniteMapX__[k,a]
  def insertWithKeyUsingInsertWith[a] (f: k -> a -> a -> a) (k:k) (x:a) (m:__FiniteMapX__[k,a]) : __FiniteMapX__[k,a]
  def insertSeqWithUsingInsertWith[a] (f: a -> a -> a) (kvs:__Seq__[(k,a)]) (m:__FiniteMapX__[k,a]) : __FiniteMapX__[k,a]
  def insertSeqWithKeyUsingInsertWithKey[a] (f: k -> a -> a -> a) (kvs:__Seq__[(k,a)]) (m:__FiniteMapX__[k,a]) : __FiniteMapX__[k,a]
  def unionSeqWithUsingReduce[a] (f: a -> a -> a) (ms: __Seq__[__FiniteMapX__[k,a]]) : __FiniteMapX__[k,a]
  def unionSeqWithUsingFoldr[a] (f: a -> a -> a) (ms: __Seq__[__FiniteMapX__[k,a]]) : __FiniteMapX__[k,a]

  def subsetUsingSubsetEq[a,b] (m1:__FiniteMapX__[k,a]) (m2:__FiniteMapX__[k,b]) : boolean

}

// __begin_Assoc__
newtype AssocDefaultModule[k] = {

  def toSeqUsingFoldWithKey[a] (m:__Assoc__[k,a]) : __Seq__[(k,a)]
  def keysUsingFoldWithKey[a] (m:__Assoc__[k,a]) : __Seq__[k]

}

// __begin_FiniteMap__
newtype FiniteMapDefaultModule[k] = {

  def unionWithUsingInsertWith[a] (f: a -> a -> a) (m1:__FiniteMap__[k,a]) (m2:__FiniteMap__[k,a]) : __FiniteMap__[k,a]
  def unionWithKeyUsingInsertWithKey[a] (f: k -> a -> a -> a) (m1:__FiniteMap__[k,a]) (m2:__FiniteMap__[k,a]) : __FiniteMap__[k,a]
  def unionSeqWithKeyUsingReduce[a] (f: k -> a -> a -> a) (ms:__Seq__[__FiniteMap__[k,a]]) : __FiniteMap__[k,a]
  def unionSeqWithKeyUsingFoldr[a] (f: k -> a -> a -> a) (ms:__Seq__[__FiniteMap__[k,a]]) : __FiniteMap__[k,a]
  def intersectWithUsingLookupM[a,b,c] (f:a -> b -> c)  (m1:__FiniteMap__[k,a]) (m2:__FiniteMap__[k,b]) : __FiniteMap__[k,c]
  def intersectWithKeyUsingLookupM[a,b,c] (f: k -> a -> b -> c)  (m1:__FiniteMap__[k,a]) (m2:__FiniteMap__[k,b]) : __FiniteMap__[k,c]
  def differenceUsingDelete[a,b] (m1:__FiniteMap__[k,a]) (m2:__FiniteMap__[k,b]) : __FiniteMap__[k,a]
  def subsetEqUsingMember[a,b] (m1:__FiniteMap__[k,a]) (m2:__FiniteMap__[k,b]) : boolean

}

// divert(0)
newtype __AssocDefaultType__ = {
  def empty:any
}
