// -*- Funnel -*-
/*  FUNNEL LIBRARY (EDISON PORT)
**  
**  CollectionDefault -- some default functions for Collections
**  
**  27/04/2001, Yacine Saidji
*/

/**
 * $Author: ysaidji $
 * $Id: CollectionDefaultType.m4,v 1.1.1.1 2001/06/26 13:20:20 ysaidji Exp $
 */

def removeMe = include[__CollectionType__]

// __begin_CollX__
newtype CollXDefaultModule[a] = {

  def insertSeqUsingUnion (xs:__Seq__[a]) (c:__CollX__[a]) : __CollX__[a]
  def insertSeqUsingFoldr (xs:__Seq__[a]) (c:__CollX__[a]) : __CollX__[a]
  def deleteSeqUsingDelete (xs:__Seq__[a]) (c:__CollX__[a]) : __CollX__[a]
  def unionSeqUsingFoldl (xss:__Seq__[__CollX__[a]]) : __CollX__[a]
  def unionSeqUsingReduce (xss:__Seq__[__CollX__[a]]) : __CollX__[a]
  def fromSeqUsingFoldr (xs:__Seq__[a]) : __CollX__[a]
  def fromSeqUsingUnionSeq (sm:__SeqModule__) (xs:__Seq__[a]) : __CollX__[a]

}

// __begin_OrdCollX__
newtype OrdCollXDefaultModule[a] = {

  def unsafeInsertMaxUsingUnsafeAppend (c:__OrdCollX__[a]) (x:a) : __OrdCollX__[a]
  def unsafeFromOrdSeqUsingUnsafeInsertMin (xs:__Seq__[a]) : __OrdCollX__[a]
}

// __begin_Coll__
newtype CollDefaultModule[a] = {

  def memberUsingFold (h:__Coll__[a]) (x:a) : boolean
  def toSeqUsingFold (sm:__SeqModule__) (c:__Coll__[a]) : __Seq__[a]
  def lookupUsingLookupAll (ys:__Coll__[a]) (x:a) : a
  def lookupWithDefaultUsingLookupAll (dflt:a) (ys:__Coll__[a]) (x:a) : a
}

// __begin_OrdColl__
newtype OrdCollDefaultModule[a] = {

  def filterUsingOrdLists (p:a->boolean) (xs:__OrdColl__[a]) : __OrdColl__[a]
  def partitionUsingOrdList (p:a->boolean) (xs:__OrdColl__[a]) : (__OrdColl__[a], __OrdColl__[a])
  def toOrdSeqUsingFoldr (sm:__SeqModule__) (c:__OrdColl__[a]) : __Seq__[a]
  def disjointUsingToOrdList (h1:__OrdColl__[a]) (h2:__OrdColl__[a]) : boolean
}

// __begin_SetX__
newtype SetXDefaultModule[a] = {

  def countUsingMember (xs:__SetX__[a]) (x:a) : int

}

// __begin_Set__
newtype SetDefaultModule[a] = {

  def fromSeqWithUsingInsertWith (c:a->a->a) (xs:__Seq__[a]) : __Set__[a]
  def insertUsingInsertWith (x:a) (s:__Set__[a]) : __Set__[a]
  def unionUsingUnionWith (s1:__Set__[a]) (s2:__Set__[a]) : __Set__[a]
  def intersectUsingIntersectWith (s1:__Set__[a]) (s2:__Set__[a]) : __Set__[a]
  def unionSeqWithUsingReducer (c:a->a->a) (cs:__Seq_[__Set__[a]]) : __Set__[a]
  def insertSeqWithUsingInsertWith (c:a->a->a) (xs:__Seq__[a]) (s:__Set__[a]) : __Set__[a]
  def unionlUsingUnionWith (s1:__Set__[a]) (s2:__Set__[a]) : __Set__[a]
  def unionrUsingUnionWith (s1:__Set__[a]) (s2:__Set__[a]) : __Set__[a]

}

// __begin_OrdSet__
newtype OrdSetDefaultModule[a] = {

  def differenceUsingOrdLists (sm:__SeqModule__) (xs:__OrdSet__[a]) (ys:__OrdSet__[a]) : __OrdSet__[a]
  def subsetUsingOrdLists (xs:__OrdSet__[a]) (ys:__OrdSet__[a]) : boolean
  def subsetEqUsingOrdLists (xs:__OrdSet__[a]) (ys:__OrdSet__[a]) : boolean
  def unionWithUsingOrdLists (sm:__SeqModule__) (c:a->a->a) (xs:__OrdSet__[a]) (ys:__OrdSet__[a]) : __OrdSet__[a]
  def intersectWithUsingOrdLists (sm:__SeqModule__) (c:a->a->a) (xs:__OrdSet__[a]) (ys:__OrdSet__[a]) : __OrdSet__[a]


}

// divert(0)
newtype __CollectionDefaultType__ = {
  def empty:any
}
