
// ------------ QuickCheck -------------------

let QuickCheck = {
  

 // ------ boolean ---------
  def qc0b[a] (f:a->boolean) (ga:Gen[a]) : Result = {
    Result.Result ( Maybe.Just[boolean] (f (ga.gen)), "", "" )
  }

  def qc1b[a,b] (f:a->b->boolean) (ga:Gen[a]) (gb:Gen[b]) : Result = {
    qc0b[b] (f (ga.gen)) (gb)
  }

  def qc2b[a,b,c] (f:a->b->c->boolean) (ga:Gen[a]) (gb:Gen[b]) (gc:Gen[c]) : Result = {
    qc1b[b,c] (f (ga.gen)) (gb) (gc)
  }

  def qc3b[a,b,c,d] (f:a->b->c->d->boolean) (ga:Gen[a]) (gb:Gen[b]) (gc:Gen[c]) (gd:Gen[d]) : Result = {
    qc2b[b,c,d] (f (ga.gen)) (gb) (gc) (gd)
  }

  def qc4b[a,b,c,d,e] (f:a->b->c->d->e->boolean) (ga:Gen[a]) (gb:Gen[b]) (gc:Gen[c]) (gd:Gen[d]) (ge:Gen[e]) : Result = {
    qc3b[b,c,d,e] (f (ga.gen)) (gb) (gc) (gd) (ge)
  }

  def qc5b[a,b,c,d,e,f] (f:a->b->c->d->e->f->boolean) (ga:Gen[a]) (gb:Gen[b]) (gc:Gen[c]) (gd:Gen[d]) (ge:Gen[e]) (gf:Gen[f]) : Result = {
    qc4b[b,c,d,e,f] (f (ga.gen)) (gb) (gc) (gd) (ge) (gf)
  }


  // ------ Result ---------
  def qc0r[a] (f:a->Result) (ga:Gen[a]) : Result = {
    f (ga.gen)
  }

  def qc1r[a,b] (f:a->b->Result) (ga:Gen[a]) (gb:Gen[b]) : Result = {
    qc0r[b] (f (ga.gen)) (gb)
  }

  def qc2r[a,b,c] (f:a->b->c->Result) (ga:Gen[a]) (gb:Gen[b]) (gc:Gen[c]) : Result = {
    qc1r[b,c] (f (ga.gen)) (gb) (gc)
  }

  def qc3r[a,b,c,d] (f:a->b->c->d->Result) (ga:Gen[a]) (gb:Gen[b]) (gc:Gen[c]) (gd:Gen[d]) : Result = {
    qc2r[b,c,d] (f (ga.gen)) (gb) (gc) (gd)
  }

  def qc4r[a,b,c,d,e] (f:a->b->c->d->e->Result) (ga:Gen[a]) (gb:Gen[b]) (gc:Gen[c]) (gd:Gen[d]) (ge:Gen[e]) : Result = {
    qc3r[b,c,d,e] (f (ga.gen)) (gb) (gc) (gd) (ge)
  }

  def qc5r[a,b,c,d,e,f] (f:a->b->c->d->e->f->Result) (ga:Gen[a]) (gb:Gen[b]) (gc:Gen[c]) (gd:Gen[d]) (ge:Gen[e]) (gf:Gen[f]) : Result = {
    qc4r[b,c,d,e,f] (f (ga.gen)) (gb) (gc) (gd) (ge) (gf)
  }


  // ------ loop ---------
  def quickcheck (f:()->Result) (fname:string): boolean = {

    val maxTest = 200
    val maxFail = 1000

    def test = f ()

    def loop (ntest:int) (nfail:int) : boolean = {
      
      //Console.println("loop " + ntest + " " + nfail)

      if      (ntest == maxTest) done (fname) ("OK, passed") (ntest)
      else if (nfail == maxFail) done (fname) ("Arguments exhausted after") (ntest)

      else {
	val res = test
	(res.ok).match {
	  def Nothing = loop (ntest) (nfail+1)
	  def Just (x) = if (x) loop (ntest+1) (nfail) else done (fname) ("Falsifiable, after ") (ntest)
	}
      }
    }
    loop (0) (0)

  }

  def done (fname:string) (mesg:string) (ntest:int) : boolean = {
    Console.println ( fname )
    Console.println ( mesg + " " + ntest )
    Console.println ("")
    true
  }

}

