// ------------- the List test -------------------

// - change the following to test another sequence implementation


/*
type Seq[a] = List[a]
let Seq = List
def gSeqInt = Gen.gListInt
def gSeqSeqInt = Gen.gListListInt
*/



type Seq[a] = SimpleQueue[a]
let Seq = SimpleQueue
let gSeqInt : Gen[SimpleQueue[int]] = {
  def gen = {
    val xs = (Gen.gListInt).gen
    val ys = (Gen.gListInt).gen
    if (xs.isEmpty) SimpleQueue.Q[int](ys,List.empty)
    else SimpleQueue.Q[int](xs,ys)
 }
}
let gSeqSeqInt : Gen[Seq[Seq[int]]] = {
  def gen = {
    let gListSeqInt : Gen[List[Seq[int]]] = Gen.gList[Seq[int]] (gSeqInt)
    val xs = gListSeqInt.gen
    val ys = gListSeqInt.gen
    if (xs.isEmpty) SimpleQueue.Q[Seq[int]](ys,List.empty)
    else SimpleQueue.Q[Seq[int]](xs,ys)
  }
}


let QTSeq = {

  with Gen
  with Result

  // Sequences comparison
  def equ (xs:Seq[int]) (ys:Seq[int]) = {
    if ( (xs.size) == (ys.size) ) (xs.zip (ys)).foldl ( b | (x,y) | (x==y) && b  ) (true)
    else false
  }

  def equL (xs:List[int]) (ys:List[int]) = {
    if ( (xs.size) == (ys.size) ) (xs.zip (ys)).foldl ( b | (x,y) | (x==y) && b  ) (true)
    else false
  }

  // the following function is used in prop_withIndex and prop_zip_zipWith
  def equTuple (xs:List[(int,int)]) (ys:List[(int,int)]) = {
    def eqt (x:int,y:int) (x':int,y':int) = (x==x') && (y==y')
    if ( (xs.size) == (ys.size) ) (xs.zip (ys)).foldl ( b | (x,y) | (eqt (x) (y)) && b  ) (true)
    else false
  }

  def equTupleS (xs:Seq[(int,int)]) (ys:Seq[(int,int)]) = {
    def eqt (x:int,y:int) (x':int,y':int) = (x==x') && (y==y')
    if ( (xs.size) == (ys.size) ) (xs.zip (ys)).foldl ( b | (x,y) | (eqt (x) (y)) && b  ) (true)
    else false
  }

  // ------ equals ----------
  def prop_equals (xs:Seq[int]) (ys:Seq[int]) : boolean = {
    equ (xs) (ys) == equL (xs.toList) (ys.toList)
  }
  def prop_equals_test : Result = QuickCheck.qc1b[Seq[int],Seq[int]] (prop_equals) (gSeqInt) (gSeqInt)

  // ------- fromList -------
  def prop_fromList (xs:List[int]) : boolean = {
    equ (Seq.fromList (xs)) (xs.foldr (Seq.cons[int]) (Seq.empty[int]))
      && equL ((Seq.fromList (xs)).toList) (xs)
  }
  def prop_fromList_test : Result = QuickCheck.qc0b[List[int]] (prop_fromList) (gListInt)

  // ------- toList -------
  def prop_toList (xs:Seq[int]) : boolean = {
    equL (xs.toList) (xs.foldr (List.cons[int]) (List.empty[int]))
      && equ (Seq.fromList (xs.toList)) (xs)
  }
  def prop_toList_test : Result = QuickCheck.qc0b[Seq[int]] (prop_toList) (gSeqInt)

  // ------ single ----------
  def prop_single (x:int) : boolean = {
    equL ((Seq.single (x)).toList) ((List.Cons[int]) (x,List.Nil[int]))
     && equ (Seq.single (x)) (Seq.snoc[int] (Seq.empty) (x))
  }
  def prop_single_test : Result = QuickCheck.qc0b[int] (prop_single) (gInt)

  // ------ cons_snoc -----------
  def prop_cons_snoc (x:int) (xs:Seq[int]) : boolean = {
    equ (Seq.cons (x) (xs)) ( (Seq.append) (Seq.single (x)) (xs))
      && equ (Seq.snoc (xs) (x)) ( (Seq.append) (xs) ((Seq.single (x))))
  }
  def prop_cons_snoc_test : Result = QuickCheck.qc1b[int,Seq[int]] (prop_cons_snoc) (gInt) (gSeqInt)

  // ------ lhead_rhead ----------
  def prop_lhead_rhead (xs:Seq[int]) : Result = {
    implies (!(xs.isEmpty)) ( | (xs.lhead == (xs.toList).lhead) && (xs.rhead == (xs.toList).rhead) )
  }
  def prop_lhead_rhead_test : Result = QuickCheck.qc0r[Seq[int]] (prop_lhead_rhead) (gSeqInt)

  // ------ ltail_rtail ----------
  def prop_ltail_rtail (xs:Seq[int]) : boolean = {
    equL ((xs.ltail).toList) ( if (xs.isEmpty) (List.Nil[int]) else ((xs.toList).ltail)  )
      && equL ((xs.rtail).toList) ( if (xs.isEmpty) (List.Nil[int]) else ((xs.toList).rtail) )
  }
  def prop_ltail_rtail_test : Result = QuickCheck.qc0b[Seq[int]] (prop_ltail_rtail) (gSeqInt)

  // ------ append ----------
  def prop_append (xs:Seq[int]) (ys:Seq[int]) : boolean = {
    equL ((Seq.append (xs) (ys)).toList)  ( List.append (xs.toList) (ys.toList) )
     && equ (Seq.append (xs) (ys)) (xs.foldr (Seq.cons[int]) (ys))
  }
  def prop_append_test : Result = QuickCheck.qc1b[Seq[int],Seq[int]] (prop_append) (gSeqInt) (gSeqInt)

  // ------ isEmpty_size ----------
  def prop_isEmpty_size (xs:Seq[int]) : boolean = {
    ( xs.isEmpty == ( xs.size == 0 ) )
      && ( xs.size == (xs.toList).size )
  }
  def prop_isEmpty_size_test : Result = QuickCheck.qc0b[Seq[int]] (prop_isEmpty_size) (gSeqInt)
  
  // ------ reverse ----------
  def prop_reverse (xs:Seq[int]) : boolean = {
    equL ((xs.reverse).toList) ((xs.toList).reverse)
      && ( if (xs.isEmpty) equ (xs.reverse) (xs)
	   else {
	     val y = xs.lhead
	     val ys = xs.ltail
	     equ ((Seq.cons (y) (ys)).reverse) (Seq.snoc (ys.reverse) (y))
	   }
	 )
  }
  def prop_reverse_test : Result = QuickCheck.qc0b[Seq[int]] (prop_reverse) (gSeqInt)

  // ------ reverseOnto ----------
  def prop_reverseOnto (xs:Seq[int]) (ys:Seq[int]) : boolean = {
    equ (Seq.reverseOnto (xs) (ys)) (Seq.append (xs.reverse) ys)
  }
  def prop_reverseOnto_test : Result = QuickCheck.qc1b[Seq[int],Seq[int]] (prop_reverseOnto) (gSeqInt) (gSeqInt)
  
  // ------ map ----------
  def prop_map (xs:Seq[int]) : boolean = {
    def f (x:int)  = x + 1
    if (xs.isEmpty) equ (xs.map (f)) (xs)
    else {
      val y = xs.lhead
      val ys = xs.ltail
      equ (xs.map (f)) (Seq.cons (f (y)) (ys.map (f)))
    }
  }
  def prop_map_test : Result = QuickCheck.qc0b[Seq[int]] (prop_map) (gSeqInt)

  // ------ fold ----------
  def prop_fold (xs:Seq[int]) : boolean = {
    def flip[a,b] (f:a->b->b) : b->a->b = (y:b | x:a | f (x) (y))
    def :: (x:int) (xs:Seq[int]) = Seq.cons (x) (xs)
    val l99 = Seq.single[int] (99)

    equ (xs.foldr (::) (l99)) (Seq.append (xs) (l99))
      && equ (xs.foldl (flip (::)) (l99)) (Seq.append (xs.reverse) (l99))
  }
  def prop_fold_test : Result = QuickCheck.qc0b[Seq[int]] (prop_fold) (gSeqInt)

  // ------ fold1 ----------
  def prop_fold1 (xs:Seq[int]) : Result = {
    def f (x:int) (y:int) : int = 3*x-2*y
    implies (!(xs.isEmpty)) ( | 
      val y  = (xs.lhead);
      val ys = (xs.ltail);
      (((Seq.snoc (ys) (y)).foldr1 (f)) == (ys.foldr (f) (y))) 
	&& ((xs.foldl1 (f)) == (ys.foldl (f) (y))) )
  }
  def prop_fold1_test : Result = QuickCheck.qc0r[Seq[int]] (prop_fold1) (gSeqInt)

  // ------ reduce ----------
  def prop_reduce (xs:Seq[int]) : boolean = {
    val a = (xs.map (Seq.single[int])).reducel (Seq.append[int]) (Seq.single (93))
    val b = Seq.append[int] (Seq.single (93)) (xs)
    val c = (xs.map (Seq.single[int])).reducer (Seq.append[int]) (Seq.single (93))
    val d = Seq.append[int] (xs) (Seq.single (93))
    equ (a) (b) && equ (c) (d)    
  }
  def prop_reduce_test : Result = QuickCheck.qc0b[Seq[int]] (prop_reduce) (gSeqInt)

  // ------ reduce1 -----------
  def prop_reduce1 (xs:Seq[int]) : Result = {
    implies (!(xs.isEmpty)) ( | equ ((xs.map[Seq[int]] (Seq.single[int])).reduce1 (Seq.append[int])) (xs) )
  }
  def prop_reduce1_test : Result = QuickCheck.qc0r[Seq[int]] (prop_reduce1) (gSeqInt)

  // ------ copy -----------
  def prop_copy (n:int) : boolean = {
    if (n<=0) equ (Seq.copy[int] (n) (42)) (Seq.empty[int])
    else equ (Seq.copy[int] (n) (42)) (Seq.cons[int] (42) (Seq.copy[int] (n-1) (42)))
  }
  def prop_copy_test : Result = QuickCheck.qc0b[int] (prop_copy) (gInt)

  // ------- tabulate --------
  def prop_tabulate (n:int) : boolean = {
    def f (x:int) : int = x+13
    def init (n':int) : List[int] = if (n'>(n+42)) List.empty[int] else List.cons (n') (init (n'+1))

    if (n<=0) equ (Seq.tabulate[int] (n) (f)) (Seq.empty[int])
    else equL ((Seq.tabulate[int] (n) (f)).toList) ((init (13)).take (n))
  }
  def prop_tabulate_test : Result = QuickCheck.qc0b[int] (prop_tabulate) (gInt)

  // ------- inBounds_lookup --------
  def prop_inBounds_lookup (i:int) (xs:Seq[int]) : boolean = {
    (xs.inBounds (i)) == (((0.toInt)<=i) && (i<(xs.size)))
      && ( if (xs.inBounds(i)) {
	     (xs.lookup (i)) == ((xs.drop (i)).lhead)
	       && (xs.lookupWithDefault (99) (i)) == (xs.lookup (i))
	   } else {
	     (xs.lookupWithDefault (99) (i)) == 99
	   }
	 )    
  }
  def prop_inBounds_lookup_test : Result = QuickCheck.qc1b[int,Seq[int]] (prop_inBounds_lookup) (gInt) (gSeqInt)

  // ------- update_adjust --------
  def prop_update_adjust (i:int) (xs:Seq[int]) : boolean = {
    if (xs.inBounds (i)) {
      val ys = xs.take (i)
      val zs = xs.drop (i+1)
      val x = xs.lookup (i)      
      equ (xs.update (i) (99)) (Seq.append (ys) (Seq.cons[int] (99) (zs)))
        && equ (xs.adjust (n:int|n+1) (i)) (Seq.append (ys) (Seq.cons[int] (x+1) (zs)))
    } else {
      equ (xs.update (i) (99)) (xs)
        && equ (xs.adjust (n:int|n+1) (i)) (xs)
    }
  }
  def prop_update_adjust_test : Result = QuickCheck.qc1b[int,Seq[int]] (prop_update_adjust) (gInt) (gSeqInt)

  // ------- withIndex --------
  def prop_withIndex (xs:Seq[int]) : boolean = {
    val ixs = (List.tabulate[int] ((xs.size)) ( n:int | n )).zip (xs.toList)
    def f (i:int) (x:int) (xs:List[(int,int)]) = List.cons ((i,x)) (xs)
    def g (xs:List[(int,int)]) (i:int) (x:int) = List.cons ((i,x)) (xs)
    equL ((xs.mapWithIndex ( i | x | (x+i) ) ).toList) (ixs.map ((x,y)|x+y))
      && equTuple (xs.foldrWithIndex (f) (List.empty[(int,int)])) (ixs)
      && equTuple ((xs.foldlWithIndex) (g) (List.empty[(int,int)])) (ixs.reverse)
  }
  def prop_withIndex_test : Result = QuickCheck.qc0b[Seq[int]] (prop_withIndex) (gSeqInt)

  // ------- take_drop_splitAt --------
  def prop_take_drop_splitAt (n:int) (xs:Seq[int]) : boolean = {
    def max (x:int) (y:int) = if (x<y) y else x
    def min (x:int) (y:int) = if (x>y) y else x
    (xs.take (n)).size == max (0) (min (n) (xs.size))
      && equ (Seq.append (xs.take (n)) (xs.drop (n))) (xs)
      && ( val (t,d) =  (xs.splitAt (n)); equ (t) (xs.take (n)) && equ (d) (xs.drop (n)) )
  }
  def prop_take_drop_splitAt_test : Result = QuickCheck.qc1b[int,Seq[int]] (prop_take_drop_splitAt) (gInt) (gSeqInt)

  // ------- subseq --------
  def prop_subseq (i:int) (len:int) (xs:Seq[int]) : boolean = {
    equ (xs.subseq (i) (len)) ((xs.drop (i)).take (len))
  }
  def prop_subseq_test : Result = QuickCheck.qc2b[int,int,Seq[int]] (prop_subseq) (gInt) (gInt) (gSeqInt)

  // ------- filter_takeWhile_dropWhile --------
  def prop_filter_takeWhile_dropWhile (x:int) (xs:Seq[int]) : boolean = {
    def p (n:int) = n < x
    if (xs.isEmpty) {
      equ (xs.filter (p)) (xs)
        && equ (xs.takeWhile (p)) (xs)
        && equ (xs.dropWhile (p)) (xs)
    } else {
      val y = xs.lhead
      val ys = xs.ltail
      equ (xs.filter (p)) ( if (p (y)) Seq.cons (y) (ys.filter (p)) else ys.filter (p) )
        &&  equ (xs.takeWhile (p)) ( if (p (y)) Seq.cons (y) (ys.takeWhile (p)) else Seq.empty[int] )
        &&  equ (xs.dropWhile (p)) ( if (p (y)) ys.dropWhile (p) else xs )
    }
  }
  def prop_filter_takeWhile_dropWhile_test : Result = QuickCheck.qc1b[int,Seq[int]] (prop_filter_takeWhile_dropWhile) (gInt) (gSeqInt)


  // ------- partition_splitWhile --------
  def prop_partition_splitWhile (x:int) (xs:Seq[int]) : boolean = {
    def p (n:int) = n < x

    val (a,a') = xs.partition (p)
    val b = xs.filter (p)
    val c = xs.filter (n| !p(n))
    val (d,d') = xs.splitWhile (p)
    val e = xs.takeWhile (p)
    val f = xs.dropWhile (p)

    equ (a) (b) && equ (a') (c)
      && equ (d) (e) && equ (d') (f)   
  }
  def prop_partition_splitWhile_test : Result = QuickCheck.qc1b[int,Seq[int]] (prop_partition_splitWhile) (gInt) (gSeqInt)


  // ------- zip_zipWith --------
  def prop_zip_zipWith (xs:Seq[int]) (ys:Seq[int]) : boolean = {
    def f (x:int) (y:int) : (int,int) = (x,y)
    if ( xs.isEmpty || ys.isEmpty ) {
      equTupleS (xs.zipWith[int,(int,int)] (f) (ys)) (Seq.empty[(int,int)])     
    } else {
      val x' = xs.lhead
      val xs' = xs.ltail
      val y' = ys.lhead
      val ys' = ys.ltail
      equTupleS (xs.zipWith[int,(int,int)] (f) (ys)) (Seq.cons (f (x') (y')) (xs'.zipWith[int,(int,int)] (f) (ys')))
        && equTupleS (xs.zip (ys)) (xs.zipWith[int,(int,int)] (f) (ys))
    }
  }
  def prop_zip_zipWith_test : Result = QuickCheck.qc1b[Seq[int],Seq[int]] (prop_zip_zipWith) (gSeqInt) (gSeqInt)

  // ------- unzip_unzipWith --------
  def prop_unzip_unzipWith (xs':Seq[int]) (ys':Seq[int]) : boolean = {
    val xys = xs'.zip (ys')
    def fst[a] (x:a,y:a) : a = x
    def snd[a] (x:a,y:a) : a = y    
    val xs = xys.map (fst[int])
    val ys = xys.map (snd[int])

    val (a,b) = Seq.unzip (xys)
    val (c,d) = Seq.unzipWith[(int,int),int] (fst[int])  (snd[int]) (xys)
    //val (c,d) = Seq.unzipWith (fst[int])  (snd[int]) (xys)

    equ (a) (xs) && equ (b) (ys)
      && equ (c) (xs) && equ (d) (ys)

  }
  def prop_unzip_unzipWith_test : Result = QuickCheck.qc1b[Seq[int],Seq[int]] (prop_unzip_unzipWith) (gSeqInt) (gSeqInt)

  // ------- concat --------
  def prop_concat (xss:Seq[Seq[int]]) : boolean = {
    equ (Seq.concat (xss)) (xss.foldr (Seq.append[int]) (Seq.empty[int]))
  }
  def prop_concat_test : Result = QuickCheck.qc0b[Seq[Seq[int]]] (prop_concat) (gSeqSeqInt)

  // ------- concatMap --------
  def prop_concatMap (xs:Seq[int]) (xss:Seq[Seq[int]]) : boolean = {
    def f (i:int) = xss.lookupWithDefault (Seq.empty) (i)
    equ (Seq.concatMap[int,int] (f) (xs)) (Seq.concat[int] (xs.map (f)))
  }
  def prop_concatMap_test : Result = QuickCheck.qc1b[Seq[int],Seq[Seq[int]]] (prop_concatMap) (gSeqInt) (gSeqSeqInt)

 
  // ------------ the test sequence -------------------
  def run = {

    val _ = QuickCheck.quickcheck (|prop_equals_test) ("prop_equals_test")
    val _ = QuickCheck.quickcheck (|prop_fromList_test) ("prop_fromList_test")
    val _ = QuickCheck.quickcheck (|prop_toList_test) ("prop_toList_test")
    val _ = QuickCheck.quickcheck (|prop_single_test) ("prop_single_test")
    val _ = QuickCheck.quickcheck (|prop_cons_snoc_test) ("prop_cons_snoc_test")
    val _ = QuickCheck.quickcheck (|prop_lhead_rhead_test) ("prop_lhead_rhead_test")
    val _ = QuickCheck.quickcheck (|prop_ltail_rtail_test) ("prop_ltail_rtail_test")
    val _ = QuickCheck.quickcheck (|prop_append_test) ("prop_append_test")
    val _ = QuickCheck.quickcheck (|prop_isEmpty_size_test) ("prop_isEmpty_size_test")
    val _ = QuickCheck.quickcheck (|prop_reverse_test) ("prop_reverse_test")
    val _ = QuickCheck.quickcheck (|prop_reverseOnto_test) ("prop_reverseOnto_test")
    val _ = QuickCheck.quickcheck (|prop_map_test) ("prop_map_test")
    val _ = QuickCheck.quickcheck (|prop_fold_test) ("prop_fold_test")    
    val _ = QuickCheck.quickcheck (|prop_fold1_test) ("prop_fold1_test")    
    val _ = QuickCheck.quickcheck (|prop_reduce_test) ("prop_reduce_test")
    val _ = QuickCheck.quickcheck (|prop_reduce1_test) ("prop_reduce1_test")
    val _ = QuickCheck.quickcheck (|prop_copy_test) ("prop_copy_test")
    val _ = QuickCheck.quickcheck (|prop_tabulate_test) ("prop_tabulate_test")
    val _ = QuickCheck.quickcheck (|prop_inBounds_lookup_test) ("prop_inBounds_lookup_test")
    val _ = QuickCheck.quickcheck (|prop_update_adjust_test) ("prop_update_adjust_test")
    val _ = QuickCheck.quickcheck (|prop_withIndex_test) ("prop_withIndex_test")
    val _ = QuickCheck.quickcheck (|prop_take_drop_splitAt_test) ("prop_take_drop_splitAt_test")
    val _ = QuickCheck.quickcheck (|prop_subseq_test) ("prop_subseq_test")
    val _ = QuickCheck.quickcheck (|prop_filter_takeWhile_dropWhile_test) ("prop_filter_takeWhile_dropWhile_test")
    val _ = QuickCheck.quickcheck (|prop_partition_splitWhile_test) ("prop_partition_splitWhile_test")
    val _ = QuickCheck.quickcheck (|prop_zip_zipWith_test) ("prop_zip_zipWith_test")
    val _ = QuickCheck.quickcheck (|prop_unzip_unzipWith_test) ("prop_unzip_unzipWith_test")
    val _ = QuickCheck.quickcheck (|prop_concat_test) ("prop_concat_test")
    val _ = QuickCheck.quickcheck (|prop_concatMap_test) ("prop_concatMap_test")    
  }

}

// -------- the test run -----------------

QTSeq.run
