// -*- Funnel -*-

/**
 * $Author: ysaidji $
 * $Id: SeqDefaultType.m4,v 1.2 2001/07/02 11:59:06 ysaidji Exp $
 */

def removeMe1 = include[__SeqType__]
def removeMe0 = include[MaybeType]

// __begin_Seq__
newtype SeqDefaultModule = {


  def snocUsingAppend[a] (s:__Seq__[a]) (x:a) : __Seq__[a]
  def snocUsingFoldr[a] (s:__Seq__[a]) (x:a) : __Seq__[a]
  def appendUsingFoldr[a] (s:__Seq__[a]) (t:__Seq__[a]) : __Seq__[a]
  def rviewDefault[a] (xs:__Seq__[a]) : Maybe[(__Seq__[a],a)]
  def rtailUsingLview[a] (xs:__Seq__[a]) : __Seq__[a]
  def concatUsingFoldr[a] (xss:__Seq__[__Seq__[a]]) : __Seq__[a]
  def reverseUsingReverseOnto[a] (s:__Seq__[a]) : __Seq__[a]
  def reverseUsingLists[a] (s:__Seq__[a]) : __Seq__[a]
  def reverseOntoUsingFoldl[a] (xs:__Seq__[a]) (ys:__Seq__[a]) : __Seq__[a]
  def reverseOntoUsingReverse[a] (xs:__Seq__[a]) (ys:__Seq__[a]) : __Seq__[a]
  def fromListUsingCons[a] (xs:List[a]) : __Seq__[a]
  def toListUsingFoldr[a] (xs:__Seq__[a]) : List[a]
  def mapUsingFoldr[a,b] (f:a->b) (xs:__Seq__[a]) : __Seq__[b]
  def concatMapUsingFoldr[a,b] (f:a->__Seq__[b]) (xs:__Seq__[a]) : __Seq__[b]
  def foldrUsingLists[a,b] (f:a->b->b) (e:b) (xs:__Seq__[a]) : b
  def foldlUsingLists[a,b] (f:b->a->b) (e:b) (xs:__Seq__[a]) : b
  def foldr1UsingLists[a] (f:a->a->a) (xs:__Seq__[a]) : a
  def foldl1UsingLists[a] (f:a->a->a) (xs:__Seq__[a]) : a
  def foldr1UsingLview[a] (f:a->a->a) (xs:__Seq__[a]) : a
  def foldl1UsingLview[a] (f:a->a->a) (xs:__Seq__[a]) : a
  def reducerUsingReduce1[a] (f:a->a->a) (e:a) (s:__Seq__[a]) : a
  def reducelUsingReduce1[a] (f:a->a->a) (e:a) (s:__Seq__[a]) : a
  def reduce1UsingLists[a] (f:a->a->a) (xs:__Seq__[a]) : a
  def copyUsingLists[a] (n:int) (x:a) : __Seq__[a]
  def tabulateUsingLists[a] (n:int) (f:int->a) : __Seq__[a]
  def tabulateUsingCons[a] (n:int) (f:int->a) : __Seq__[a]
  def inBoundsUsingDrop[a] (s:__Seq__[a]) (i:int) : boolean
  def inBoundsUsingLookupM[a] (s:__Seq__[a]) (i:int) : boolean
  def inBoundsUsingSize[a] (s:__Seq__[a]) (i:int) : boolean
  def lookupUsingLookupM[a] (s:__Seq__[a]) (i:int) : a
  def lookupUsingDrop[a] (s:__Seq__[a]) (i:int) : a
  def lookupWithDefaultUsingLookupM[a] (d:a) (s:__Seq__[a]) (i:int) : a
  def lookupWithDefaultUsingDrop[a] (d:a) (s:__Seq__[a]) (i:int) : a
  def lookupMUsingDrop[a] (s:__Seq__[a]) (i:int) : Maybe[a]
  def filterUsingLview[a] (p:a->boolean) (xs:__Seq__[a]) : __Seq__[a]
  def filterUsingLists[a] (p:a->boolean) (xs:__Seq__[a]) : __Seq__[a]
  def filterUsingFoldr[a] (p:a->boolean) (xs:__Seq__[a]) : __Seq__[a]
  def partitionUsingLists[a] (p:a->boolean) (xs:__Seq__[a]) : (__Seq__[a],__Seq__[a])
  def partitionUsingFoldr[a] (p:a->boolean) (xs:__Seq__[a]) : (__Seq__[a],__Seq__[a])
  def updateUsingAdjust[a] (i:int) (y:a) (s:__Seq__[a]) : __Seq__[a]
  def updateUsingSplitAt[a] (i:int) (y:a) (s:__Seq__[a]) : __Seq__[a]
  def adjustUsingLists[a] (f:a->a) (i:int) (s:__Seq__[a]) : __Seq__[a]
  def adjustUsingSplitAt[a] (f:a->a) (i:int) (s:__Seq__[a]) : __Seq__[a]
  def mapWithIndexUsingLists[a,b] (f:int->a->b) (xs:__Seq__[a]) : __Seq__[b]
  def foldrWithIndexUsingLists[a,b] (f:int->a->b->b) (e:b) (xs:__Seq__[a]) : b
  def foldlWithIndexUsingLists[a,b] (f:b->int->a->b) (e:b) (xs:__Seq__[a]) : b
  def takeUsingLists[a] (i:int) (s:__Seq__[a]) : __Seq__[a]
  def takeUsingLview[a] (i:int) (s:__Seq__[a]) : __Seq__[a]
  def dropUsingLists[a] (i:int) (s:__Seq__[a]) : __Seq__[a]
  def dropUsingLtail[a] (i:int) (s:__Seq__[a]) : __Seq__[a]
  def splitAtDefault[a] (i:int) (s:__Seq__[a]) : (__Seq__[a],__Seq__[a])
  def splitAtUsingLview[a] (i:int) (s:__Seq__[a]) : (__Seq__[a],__Seq__[a])
  def subseqDefault[a] (i:int) (len:int) (xs:__Seq__[a]) : __Seq__[a]
  def takeWhileUsingLview[a] (p:a->boolean) (xs:__Seq__[a]) : __Seq__[a]
  def dropWhileUsingLview[a] (p:a->boolean) (xs:__Seq__[a]) : __Seq__[a]
  def splitWhileUsingLview[a] (p:a->boolean) (xs:__Seq__[a]) : (__Seq__[a],__Seq__[a])
  def zipUsingLview[a,b] (xs:__Seq__[a]) (ys:__Seq__[b]) : __Seq__[(a,b)]
  def zip3UsingLview[a,b,c] (xs:__Seq__[a]) (ys:__Seq__[b]) (zs:__Seq__[c]) : __Seq__[(a,b,c)]
  def zipWithUsingLview[a,b,c] (f:a->b->c) (xs:__Seq__[a]) (ys:__Seq__[b]) : __Seq__[c]
  def zipWith3UsingLview[a,b,c,d] (f:a->b->c->d) (xs:__Seq__[a]) (ys:__Seq__[b]) (zs:__Seq__[c]) : __Seq__[d]
  def zipUsingLists[a,b] (xs:__Seq__[a]) (ys:__Seq__[b]) : __Seq__[(a,b)]
  def zip3UsingLists[a,b,c] (xs:__Seq__[a]) (ys:__Seq__[b]) (zs:__Seq__[c]) : __Seq__[(a,b,c)]
  def zipWithUsingLists[a,b,c] (f:a->b->c) (xs:__Seq__[a]) (ys:__Seq__[b]) : __Seq__[c]
  def zipWith3UsingLists[a,b,c,d] (f:a->b->c->d) (xs:__Seq__[a]) (ys:__Seq__[b]) (zs:__Seq__[c]) : __Seq__[d]
  def unzipUsingLists[a,b] (xys:__Seq__[(a,b)]) : (__Seq__[a],__Seq__[b])
  def unzipUsingFoldr[a,b] (xys:__Seq__[(a,b)]) : (__Seq__[a],__Seq__[b])
  def unzip3UsingLists[a,b,c] (xyzs:__Seq__[(a,b,c)]) : (__Seq__[a],__Seq__[b],__Seq__[c])
  def unzip3UsingFoldr[a,b,c] (xyzs:__Seq__[(a,b,c)]) : (__Seq__[a],__Seq__[b],__Seq__[c])
  def unzipWithUsingLists[a,b,c] (f:a->b) (g:a->c) (xys:__Seq__[a]) : (__Seq__[b],__Seq__[c])
  def unzipWithUsingFoldr[a,b,c] (f:a->b) (g:a->c) (xys:__Seq__[a]) : (__Seq__[b],__Seq__[c])
  def unzipWith3UsingLists[a,b,c,d] (f:a->b) (g:a->c) (h:a->d) (xyzs:__Seq__[a]) :  (__Seq__[b],__Seq__[c],__Seq__[d])
  def unzipWith3UsingFoldr[a,b,c,d] (f:a->b) (g:a->c) (h:a->d) (xyzs:__Seq__[a]) :  (__Seq__[b],__Seq__[c],__Seq__[d])

 

}

// divert(0)
newtype __SeqDefaultType__ = {
  def empty:any
}
