/*  DSP LIBRARY
**  
**  complex -- support for complex numbers
**  
**  15/05/2001, Yacine Saidji
*/

// "Michel style" primitive functions
def cos (t:double): double =
  primitive(1, "java.lang.Math", "cos", "(D)D") (t)

def sin (t:double): double =
  primitive(1, "java.lang.Math", "sin", "(D)D") (t)

newtype Complex = {
  def re : double
  def im : double
  def add (c:Complex): Complex
  def mul (c:Complex): Complex
  def sub (c:Complex): Complex
}

type ComplexModule = {
  def toComplex (x:int) : Complex 
  def Complex(x:double,y:double): Complex
  def cis (t:double): Complex
}

let Complex: ComplexModule = {

  def toComplex (x:int) : Complex = Complex( x.toDouble, 0.0 )


  def Complex (r:double, i:double) = {
    def re = r
    def im = i
    def add (c) = Complex (r+c.re, i+c.im)
    def sub (c) = Complex (r-c.re, i-c.im)
    def mul (c) = {
      val tempr = (r*c.re) - (i*c.im);
      val tempi = (r*c.im) + (i*c.re);
      Complex(tempr,tempi)
    }
  }

  def cis (t) = Complex(cos (t), sin (t))

}

