
def printComplex (cs:List[Complex]) : () = {
  def printC (i:int) (x:Complex): () = {
    Console.println ("["+i+":\t"+x.re+"\t"+x.im+"]")
  }
  cs.iterateWithIndex (printC)
}

def print (i:int) (x:Complex): Complex = (Console.println ("["+i+":\t"+x.re+"\t"+x.im+"]"); x)  

val data = (List.tabulate[Complex]) 8 (i:int|Complex.Complex(i.toDouble, 0.0))
val transformed = Fft.fft(data)
val restored = Fft.ifft(transformed)

Console.println("--------- original -----------")
val toto = data.mapWithIndex (print)

Console.println("--------- transformed -----------")
val titi = transformed.mapWithIndex (print)

Console.println("--------- restored -----------")
val tutu = (Fft.scale(restored)).mapWithIndex (print)
